/* Controller */

#import <Cocoa/Cocoa.h>
#import <iostream>
#import "Distances.h"
#import "Keyboard.h"
#import "KeyboardLayout.h"
#import "Hands.h"
#import "KeyboardGLView.h"
#import "KeyboardView.h"
#import "ProgressDisplay.h"

using namespace::std;

@interface Controller : NSObject
{
/**************************************************************************
 * C++ Variables
 **************************************************************************/
	Keyboard *macKeyboard;
	KeyboardLayout *dvorak;
	KeyboardLayout *qwerty;
	Hands *dvorakTypist;
	Hands *qwertyTypist;

/**************************************************************************
 * Objective-C Variables
 **************************************************************************/
	NSArray *fileTypes;

/**************************************************************************
 * Interface Builder Outlets
 **************************************************************************/
    IBOutlet NSWindow *applicationWindow;
    IBOutlet NSMatrix *dvorakDistance;
    IBOutlet NSMatrix *dvorakDistanceLabels;
    IBOutlet KeyboardView *dvorakView;
    IBOutlet NSMatrix *qwertyDistance;
    IBOutlet NSMatrix *qwertyDistanceLabels;
    IBOutlet KeyboardView *qwertyView;
    IBOutlet NSProgressIndicator *progressBar;
    IBOutlet NSWindow *progressBarWindow;
    IBOutlet ProgressDisplay *progressDisplay;
    IBOutlet NSTextField *progressStatusLabel;
    IBOutlet NSTextView *textArea;
}

/**************************************************************************
 * Prototypes
 **************************************************************************/
- (void)awakeFromNib;
- (void)displayDistance1:(double)keyboardDistance1 distance2:(double)keyboardDistance2;
- (IBAction)analyzeTextField:(id)sender;
- (void)typeTextString:(NSString *)textInput;
- (IBAction)openFileWithPanel:(id)sender;
- (void)openPanelDidEnd:(NSOpenPanel *)openPanel returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (void)analyzeFiles:(NSArray *)filesToOpen;

@end
