#import "KeyboardGLView.h"

@implementation KeyboardGLView

/**************************************************************************
 * awakeFromNib
 *	called when interface in unpacked
 *	sets up data
 **************************************************************************/
- (void)awakeFromNib{
	//maybe I'll need it someday
}

/*********************************************************************************
 * initWithCoder
 *  called at class creation
 *********************************************************************************/
- (id) initWithCoder: (NSCoder *) coder{
	long swapInterval = 1;
	
	NSOpenGLPixelFormatAttribute pixelAttributes[] = { NSOpenGLPFADoubleBuffer, nil};
	NSOpenGLPixelFormat *pixelFormat;
	self = [super initWithCoder: coder];
	
	pixelFormat = [[NSOpenGLPixelFormat alloc] initWithAttributes: pixelAttributes];
	[self setPixelFormat:pixelFormat];
	[[self openGLContext] 
		setValues: &swapInterval
		forParameter: NSOpenGLCPSwapInterval
	];
	
	return self;
}


/**************************************************************************
 * drawRect
 *	draws the view
 **************************************************************************/
- (void)drawRect:(NSRect)bounds {
	int keycode;
	int row;
	float offset, keyWidth, keyHeight, rowHeight;
	rowHeight = keyboard->getRowHeight();
	keyHeight = keyboard->getKeyHeight();
	char letterLabel[] = {'\0', '\0'};

	glLoadIdentity();
	//gluOrtho2D(0, bounds.size.width, bounds.size.height, 0); //left, right, bottom, top
	gluOrtho2D(0, 11.125, 3.75, 0); //left, right, bottom, top
	glClearColor(0.73,0.73,0.73,0);
	glClear( GL_COLOR_BUFFER_BIT );
	glViewport(0, 0, (int) bounds.size.width, (int) bounds.size.height);
		
	for(keycode = 0; keycode < NUMBER_KEYCODES; keycode++){
		Key *thisKey = keyboard->getKey(keycode);
		keyWidth = thisKey->getKeyWidth();
		offset = thisKey->getOffset();
		row = thisKey->getRow();
		
		glColor3ub(68, 68, 68); //KeyCaps key color; a dark grey
		glBegin( GL_QUADS );
			glVertex2f(offset, row*rowHeight );
			glVertex2f(offset, row*rowHeight + keyHeight );
			glVertex2f(offset + keyWidth, row*rowHeight + keyHeight );
			glVertex2f(offset + keyWidth, row*rowHeight );
		glEnd();
		
		letterLabel[0] = keyboardLayout->getCharacterForKeycode(keycode);
		if(letterLabel[0] != '\0'){
			NSString *keyCap = [NSString stringWithCString:letterLabel];
			//NSString *keyCap = [NSString stringWithCString:(&keyboardLayout->getCharacterForKeycode(keycode)) length:1];
			NSMutableDictionary *attributes = [NSMutableDictionary dictionary];
			
			//[[NSColor whiteColor] set];
			//NSRect
			[keyCap drawAtPoint:NSMakePoint(offset, row*rowHeight + keyHeight) withAttributes:attributes];
		}
	}

	glFinish();
	[[self openGLContext] flushBuffer];
}


/**************************************************************************
 * drawKeyboard
 *	draws all the keys up on the screen!
 **************************************************************************/
- (void)drawKeyboard:(Keyboard *)keyboardToDraw layout:(KeyboardLayout *)keyboardLayoutToDraw{
	keyboard = keyboardToDraw;
	keyboardLayout = keyboardLayoutToDraw;
	[self setNeedsDisplay: YES];
}

@end
