/* KeyboardView */

#import <Cocoa/Cocoa.h>
#import "Keyboard.h"
#import "KeyboardLayout.h"

@interface KeyboardView : NSView
{
	Keyboard *keyboard;
	KeyboardLayout *keyboardLayout;
	float keyboardHeight;
	float viewScaleFactor;
}

- (void) drawRect: (NSRect) bounds;
- (void)setKeyboard:(Keyboard *)keyboardToDraw layout:(KeyboardLayout *)keyboardLayoutToDraw;
- (NSPoint)keyboardPointToView:(NSPoint)keyboardPoint;
- (NSPoint)keyboardPointToView:(float)x y:(float)y;
- (NSRect)makeKeyboardNSRect:(NSPoint)origin dimensions:(NSSize)dimensions;

@end
