#import "KeymileageWindow.h"

/**********************************************
 *
 * KeymileageWindow
 *  subclass of NSWindow
 *  implements drag-and-drop methods
 *  most of which are dumped on to the window delegate
 *
 **********************************************/

@implementation KeymileageWindow


/**************************************************************************
 * draggingEntered
 *	specifies which cursor image to depict for this drag
 **************************************************************************/
- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender {
	return [[self delegate] draggingEntered:sender];
}

/* draggingExited--if the dragged file leaves the window */
- (void)draggingExited:(id <NSDraggingInfo>)sender{
}

/* prepareForDragOperation--authorizes the drag)*/
- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender{
	return YES;
}

/**************************************************************************
 * performDragOperation
 *	the guts of the drag operation
 **************************************************************************/
- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender{
	return [[self delegate] performDragOperation:sender];
}

@end