/* ProgressDisplay */

#import <Cocoa/Cocoa.h>

@interface ProgressDisplay : NSObject
{
/**************************************************************************
 * Interface Builder Outlets
 **************************************************************************/
    IBOutlet NSProgressIndicator *progressBar;
    IBOutlet NSWindow *progressBarWindow;
	
/**************************************************************************
 * Objective-C Variables
 **************************************************************************/
	NSDate *startTime;
	NSDate *timeOfLastUpdate;
	NSModalSession progressModalSession; //a modal session for the progress bar window
	NSTimeInterval secondsPerUpdate; //update the progress bar every sixth of a second
	NSTimeInterval startProgressBarAt;
}

/**************************************************************************
 * Prototypes
 **************************************************************************/
- (BOOL)updateIfNeededTo:(double)newValue;
- (void)openIndeterminateWithModality:(BOOL)runAsModalSession;
- (void)startWithMaximum:(double)newMaximum;
- (void)endUpdating;

@end
