/*
 *  finger.h
 *  Keymileage
 *
 *  Created by Allen Smith on Thu Feb 26 2004.
 *
 */

#include "standardFunctions.h"

//the global number of strokes which a typed key
//may wait before returning to the default position
extern int numberStrokesTillDefault;

class Finger{
	private:
		Coordinate currentPosition;
		Coordinate defaultPosition;
		int strokesTillDefault; //how many keypresses are to be made until this key reverts to the default
		double totalInchesTraveled; //for this finger
		int totalStrokes; //how many letters this finger has typed
	public:
		Finger();
		Finger(Coordinate);
		float decrementStrokeCounter(); //signals that another stroke has been pressed on a different key
		float typeFinger(Coordinate *);
		double getInchesTraveled();
		Coordinate getCurrentPosition();
		float forceReturnToDefault();
		void resetFinger(); //clears data for the finger (used to start analyzing a new file)
	private:
		float moveFinger(Coordinate *);
};