/**********************************************
 *
 * key.h
 *
 **********************************************/

#ifndef KEY_H
#define KEY_H


#include "standardFunctions.h"

class Key {

	private:
		int keycode;
		Coordinate strikepoint; //strikepoint
		float offset; //inches from left edge of keyboard to left edge of key
		float keyWidth; //in inches
		int finger;
		int row; //code number for row; the number row is 0, the home row is 2, etc.
		int position; //how many standard-sized keys are to the left of this one. Both '~' and 'A' have position 0.
	
	public:
		Key();
		Key(int, int, int, int, float, float, Coordinate); //constructor for normal keys
		Key(int, float, float, Coordinate, int, int); //constructor for absolutely-positioned keys
		Coordinate* getStrikepoint();
		void setStrikepoint(float, float);
		int getFinger();
		int getKeycode();
		float getKeyWidth();
		float getOffset();
		int getPosition();
		int getRow();
		
}; //end class


#endif