/**********************************************
 *
 * keyboard.h
 *
 **********************************************/
#ifndef KEYBOARD_H
#define KEYBOARD_H


#include "key.h"

#define NUMBER_KEYCODES 256

class Keyboard {

	private:
		Key key[NUMBER_KEYCODES]; //key chart indexed by keycode
		float rowHeight; //the height of one row of keys (inches)
		float keyHeight; //the height of the keys themselves (inches)
		float keyWidth; //width of the keys themselves (inches)
		float keySpacing; //amount of space between each key (inches)
		float keyboardWidth; //the total width of this keyboard (inches)
		float keyboardHeight; //the total height of this keyboard (inches)
		int row[4][18]; //a two-dimensional array of rows of keyscodes. Non-standard keys are excluded.
		float rowOffset[4]; //number of inches occupied by any non-standard sized keys on the left side of the row
	
	public:
		Keyboard(const char *); //constructor
		Key *getKey(int); //by keycode
		Key getKeyByRowPosition(int, int);
		float getKeyHeight();
		float getRowHeight();
		Dimensions getKeyboardDimensions();
}; //end class


#endif