/*
 *  keyboardLayout.h
 *  Keymileage
 *
 *  Created by Allen Smith on Tue Feb 24 2004.
 *
 */
#ifndef KEYBOARDLAYOUT_H
#define KEYBOARDLAYOUT_H


class KeyboardLayout{
	private:
		int keycodes[256]; //resolves ascii codes to keycodes! (index is the ascii code)
		int characters[256]; //resolves keycodes codes to ascii codes! (index is the keycode)
		bool shifted[256]; //is the shift key down for pressing this ascii?
		int shiftKey[2]; //left and right shift keycodes
		int capsLock; //keycode for CapsLock
		bool capsLockDown; //state of CapsLock key
	public:
		KeyboardLayout(const char *);
		unsigned char getCharacterForKeycode(int);
		int getKeycodeForCharacter(unsigned char);
		bool isShifted(unsigned char);
		int getShiftKeycode(int);
		unsigned char xmodmapStringToASCII(char *);
		bool isCapsLockDown();
		void setCapsLock(bool);
};


#endif