#include <iostream>
#include <string.h>
#include "keyboard.h"
#include "keyboardLayout.h"
#include "hands.h"

using std::cout;
using std::cin;
using std::endl;

Keyboard macKeyboard("Keyboard Data");
KeyboardLayout dvorak("dvorak.keysym");
KeyboardLayout qwerty("qwerty.keysym");
Hands dvorakTypist( &macKeyboard, &dvorak );
Hands qwertyTypist( &macKeyboard, &qwerty );


int main (int argc, const char * argv[]) {
	char testString[1024];
	
	while(true){
		cout << "Enter a string to analyze:\n";
		cin.getline(testString, 1024);
		cout << testString << endl;
		int testStringLength = strlen(testString);
		for(int counter = 0; counter < testStringLength; counter++){
			dvorakTypist.typeCharacter(testString[counter]);
			qwertyTypist.typeCharacter(testString[counter]);
		}
		dvorakTypist.returnToHomeRow();
		qwertyTypist.returnToHomeRow();
		
		cout << "Dvorak: " << dvorakTypist.getDistance() << endl;
		cout << "Qwerty: " << qwertyTypist.getDistance() << endl;
		
		dvorakTypist.resetHands();
		qwertyTypist.resetHands();
	}
	return 0;
}